TranslatingTermConsumer Class Reference

`#include <TranslatingTermConsumer.h>`

Inheritance diagram for TranslatingTermConsumer:

## Public Member Functions

| TranslatingTermConsumer (BigTermConsumer &consumer, const TermTranslator &translator)
| TranslatingTermConsumer (unique_ptr< BigTermConsumer > consumer, const TermTranslator &translator)
virtual void | beginConsumingList ()
| Tell the consumer that the ideals that are consumed until the next call to doneConsumingList are to be considered as one list of ideals, rather than as a number of separate ideals.
virtual void | consumeRing (const VarNames &names)
| Tell the consumer which ring is being used.
virtual void | beginConsuming ()
| Tell the consumer to begin consuming an ideal.
virtual void | consume (const Term &term)
| Consume a term.
virtual void | consume (const vector< mpz_class > &term)
virtual void | consume (const Term &term, const TermTranslator &translator)
virtual void | doneConsuming ()
| Must be called once after each time beginConsuming has been called.
virtual void | doneConsumingList ()
| Must be called once after each time beginConsumingList has been called.
virtual void | consume (const BigIdeal &ideal)
Public Member Functions inherited from BigTermConsumer
virtual | ~BigTermConsumer ()
virtual void | consume (unique_ptr< BigIdeal > ideal)
void | beginConsuming (const VarNames &names)
Public Member Functions inherited from TermConsumer
virtual | ~TermConsumer ()
void | consume (const Ideal &ideal)
| This is a non-virtual utility method that calls the other methods to achieve its effect of calling beginConsuming, then consuming all generators, and then calling doneConsuming.

## Private Attributes

const TermTranslator & | _translator
BigTermConsumer & | _consumer
unique_ptr< BigTermConsumer > | _consumerOwner

## Detailed Description

Definition at line 30 of file TranslatingTermConsumer.h.

## Constructor & Destructor Documentation

## TranslatingTermConsumer() [1/2]

TranslatingTermConsumer::TranslatingTermConsumer | ( | BigTermConsumer & | consumer,
|  | const TermTranslator & | translator )

Definition at line 24 of file TranslatingTermConsumer.cpp.

## TranslatingTermConsumer() [2/2]

TranslatingTermConsumer::TranslatingTermConsumer | ( | unique_ptr< BigTermConsumer > | consumer,
|  | const TermTranslator & | translator )

Definition at line 30 of file TranslatingTermConsumer.cpp.

## Member Function Documentation

## beginConsuming()

void TranslatingTermConsumer::beginConsuming | ( |  | ) |

virtual

Tell the consumer to begin consuming an ideal.

It is required to call this method before calling consume().

Implements BigTermConsumer.

Definition at line 46 of file TranslatingTermConsumer.cpp.

## beginConsumingList()

void TranslatingTermConsumer::beginConsumingList | ( |  | ) |

virtual

Tell the consumer that the ideals that are consumed until the next call to doneConsumingList are to be considered as one list of ideals, rather than as a number of separate ideals.

The default implementation is to ignore this, but the consumer is free to do something special in this case. It is thus not in general required to call this method, but if you don't, make sure that every consumer that you want to use does what you want if you output more than a single ideal.

Reimplemented from TermConsumer.

Definition at line 38 of file TranslatingTermConsumer.cpp.

## consume() [1/4]

void TranslatingTermConsumer::consume | ( | const BigIdeal & | ideal | ) |

virtual

Reimplemented from BigTermConsumer.

Definition at line 73 of file TranslatingTermConsumer.cpp.

## consume() [2/4]

void TranslatingTermConsumer::consume | ( | const Term & | term | ) |

virtual

Consume a term.

Reimplemented from BigTermConsumer.

Definition at line 50 of file TranslatingTermConsumer.cpp.

## consume() [3/4]

void TranslatingTermConsumer::consume | ( | const Term & | term,
|  | const TermTranslator & | translator )

virtual

Implements BigTermConsumer.

Definition at line 60 of file TranslatingTermConsumer.cpp.

## consume() [4/4]

void TranslatingTermConsumer::consume | ( | const vector< mpz_class > & | term | ) |

virtual

Implements BigTermConsumer.

Definition at line 56 of file TranslatingTermConsumer.cpp.

## consumeRing()

void TranslatingTermConsumer::consumeRing | ( | const VarNames & | names | ) |

virtual

Tell the consumer which ring is being used.

Implements BigTermConsumer.

Definition at line 42 of file TranslatingTermConsumer.cpp.

## doneConsuming()

void TranslatingTermConsumer::doneConsuming | ( |  | ) |

virtual

Must be called once after each time beginConsuming has been called.

Implements BigTermConsumer.

Definition at line 65 of file TranslatingTermConsumer.cpp.

## doneConsumingList()

void TranslatingTermConsumer::doneConsumingList | ( |  | ) |

virtual

Must be called once after each time beginConsumingList has been called.

Reimplemented from TermConsumer.

Definition at line 69 of file TranslatingTermConsumer.cpp.

## Member Data Documentation

## _consumer

BigTermConsumer& TranslatingTermConsumer::_consumer

private

Definition at line 59 of file TranslatingTermConsumer.h.

## _consumerOwner

unique_ptr<BigTermConsumer> TranslatingTermConsumer::_consumerOwner

private

Definition at line 60 of file TranslatingTermConsumer.h.

## _translator

const TermTranslator& TranslatingTermConsumer::_translator

private

Definition at line 58 of file TranslatingTermConsumer.h.

The documentation for this class was generated from the following files:

- src/TranslatingTermConsumer.h
- src/TranslatingTermConsumer.cpp